<?php

/**
 * Execute a given command with asmonitor, and return the result
 */
class cmd_test
{
	/** Service status names */
	static $status = array(
		0 => 'OK',
		1 => 'WARNING',
		2 => 'CRITICAL',
		3 => 'UNKNOWN'
	);

	/** Host status names */
	static $host_status = array(
		0 => 'OK',
		1 => 'DOWN',
		2 => 'UNREACHABLE'
	);

	/**
	 * Print error and die
	 */
	function crash($msg)
	{
		echo $msg . "<br />\n";
		exit;
	}

	/**
	 * Expand macros in a way similar to how nagios would do it
	 */
	function expandmacros($cmd, $macros) {
		$macros[''] = '$';
		$in_macro = false;
		$index = 0;
		$next_dollar = strpos($cmd, '$');
		while ($next_dollar !== false) {
			$macro_name = substr($cmd, $index+1, $next_dollar - $index - 1);
			if ($in_macro && isset($macros[$macro_name])) {
				$oldlen = strlen($cmd);
				$cmd = substr($cmd, 0, $index) . $macros[$macro_name] . substr($cmd, $next_dollar + 1);
				$next_dollar += strlen($cmd) - $oldlen;
			}

			$in_macro = !$in_macro;
			$index = $next_dollar;
			$next_dollar = strpos($cmd, '$', $index + 1);
		}

		$cmd = str_replace('\\\\', '\\', $cmd);
		return $cmd;
	}

	/**
	 * Given a command, run it and return the output
	 */
	function runcmd($cmd, $macros = array(), $node = false)
	{
		$cmd = self::expandmacros($cmd, $macros);
		if ($node)
			$cmd = "/usr/bin/asmonitor -q '/usr/bin/mon' 'node' 'ctrl' '$node' '--' '/usr/bin/asmonitor' ".escapeshellarg($cmd);
		else
			$cmd = "/usr/bin/asmonitor " . $cmd;
		exec($cmd . ' 2>&1', $output, $ret);
		echo "Plugin return code: $ret ";
		if (isset(self::$status[$ret])) {
			echo '(';
			echo "status: ".self::$status[$ret];
			echo ')';
		}
		echo "\n\n";
		if (!$node)
			echo "Command: $cmd\n";
		echo join("\n", $output) . "\n";
	}
}
