<?php

require_once('checkbox.php');

/**
 * Specialized checkbox widget for selecting a user's permissions
 */
class access_widget extends checkbox_widget {
	static private $id = 0;
	function render($obj, $token, $value) {
		$options = $obj->properties['special'][$token];
		$obj_val = $value;
		$name = $obj->type . "[" . $obj->id . "][" . $token . "]";

		if (!is_array($obj_val)) {
			$cur = explode(',', $obj_val);
		} else {
			if (count($obj_val) > 1 && isset($obj_val['n']))
			  unset($obj_val['n']);

			$cur = array_keys($obj_val);
		}

		echo "<table class='box-table' summary=\"\">\n";
		foreach($options as $opt => $opt_str) {
			if($opt_str === false) {
				echo "   <input type='hidden' name='" . $name .
				  "[" . $opt . "]' value='$opt_str' />\n";
				continue;
			}

			echo "<tr>\n";
			$html_id = 'checkbox_'.preg_replace('~[[\] ]+~', '_', $name).'_'.$opt;
			printf("  <td class=\"checkbox\"><input type='checkbox' id='%s' name='%s[%s]' %s class=\"auto accessbox%s\" />\n",
				$html_id,
				$name, $opt,
				in_array($opt, $cur) ? "checked='checked'" : "",
				self::$id);
			echo "  </td>\n";
			echo "  <td><label for='$html_id'>$opt_str</label></td>\n</tr>";
		}
		echo "<tr>\n";
		echo "<td class=\"checkbox\"><input type=\"checkbox\" id='selectall_accessbox-".self::$id."' class=\"selectall_accessbox accessbox".self::$id."\" title=\"Toggle the selection of all checkboxes for this user\" />\n";
		echo "</td>\n<td><label for='selectall_accessbox-".self::$id."'>Select all</label></td>\n</tr>";

		echo "</table>\n";
		self::$id++;
	}
}
