<?php

require_once('checkbox.php');

/**
 * Specialized checkbox widget for selecting a user's permissions
 */
class enable_access_widget extends base_widget {

	/**
	 * @return string
	 */
	private function _render_javascript() {
		$js = <<<JS
<script>
$(function() {
	// Hide access stuff on load
	var access_rows = $('.password_row, .groups_row, .realname_row')
	access_rows.hide();

	$('.enable_access_widget').click(function() {
		var checkbox = $(this);

		// Enable the hidden access rights-config
		if(checkbox.get(0).checked) {
			if($.browser.msie) {
				access_rows.show();
			} else {
				access_rows.fadeIn();
			}
		} else {
			if($.browser.msie) {
				access_rows.hide();
			} else {
				access_rows.fadeOut();
			}
		}
	});

	// Trigger on load when back button is used
	if($('.enable_access_widget:checked').length) {
		// we want the event handler but not the click, hence the restored the state
		$('.enable_access_widget')
			.trigger('click')
			.attr('checked', 'checked');
	}
});
</script>
JS;
		return $js;
	}

	/**
	 * @param $obj object_class
	 * @param $token
	 * @param $value string
	 */
	function render($obj, $token, $value) {
		$html = <<<HTML
	<label><input type="checkbox" class="enable_access_widget" name="enable_access_widget" value="1" /> Configure access rights for this contact</label>
HTML;
		echo $html;
		echo $this->_render_javascript();
	}

	/**
	 * @param $obj object_class
	 * @param $token
	 * @param $value string
	 */
	static function validate($obj, $token, $value) {
		return $value;
	}
}
