<?php
//Check if APC is installed on the machine
$apc = function_exists('apc_fetch');
$apc_not_installed = "APC is not installed on this machine.";

//Fields specific for common
$common_fields = array(
	'session_key'		=> array( 'input' => 'string', 'value' => ''),
	'default_auth'		=> array( 'input' => 'select', 'value' => ''),						//Select between drivers
	'apc_enabled'		=> array( 'input' => 'bool', 'value' => '1', 'apc' => $apc),	//true, false. Cannot be true if apc is not installed.
	'apc_ttl'			=> array( 'input' => 'int', 'value' => '', 'apc' => $apc),			//greyed out if apc is not installed
	'apc_store_prefix'	=> array( 'input' => 'string', 'value' => '', 'apc' => $apc)			//greyed out if apc is not installed
);

//Fields specific for Default
$Default_fields = array(

);

//Fields specific for LDAP
$LDAP_fields = array(
	'server'			=> array( 'input' => 'string', 'value' => ''),
	'port'				=> array( 'input' => 'int', 'value' => false),						//int or empty for false
	'encryption'		=> array( 'input' => 'select', 'value' => 'none,ssl,start_tls'),	//none, ssl, start_tls
	'bind_dn'			=> array( 'input' => 'string', 'value' => false),						//string or empty for false
	'bind_secret'		=> array( 'input' => 'string', 'value' => false),						//string or empty for false. Could also contain a path to secret file
	'base_dn'			=> array( 'input' => 'string', 'value' => ''),
	'user_base_dn'		=> array( 'input' => 'string', 'value' => ''),
	'user_filter'		=> array( 'input' => 'string', 'value' => ''),
	'group_base_dn'		=> array( 'input' => 'string', 'value' => ''),
	'group_filter'		=> array( 'input' => 'string', 'value' => ''),
	'groupkey'			=> array( 'input' => 'string', 'value' => ''),
	'group_recursive'	=> array( 'input' => 'bool', 'value' => '1'),
	'upn_suffix'		=> array( 'input' => 'string', 'value' => ''),
	'userkey'			=> array( 'input' => 'string', 'value' => ''),
	'userkey_is_upn'	=> array( 'input' => 'bool', 'value' => '1'),
	'userkey_realname'	=> array( 'input' => 'string', 'value' => ''),
	'userkey_email'		=> array( 'input' => 'string', 'value' => ''),
	'memberkey'			=> array( 'input' => 'string', 'value' => ''),
	'memberkey_is_dn'	=> array( 'input' => 'bool', 'value' => '1'),
	'bind_with_upn'		=> array( 'input' => 'bool', 'value' => '1'),
	'protocol_version'	=> array( 'input' => 'int', 'value' => '')	
);

//Fields specific for Apache
$Apache_fields = array(

);

function driverForm($driver, $newForm = false, $settings = false) {
	if ($newForm)
		$module = $newForm;
	else
		$module = $settings['driver'];
	global ${$module . '_fields'}, $apc;
	$field_array = ${$module . '_fields'};
	$html = "<table class=''>\n";
	$html .= "<tr>\n";
	$html .= "<td><label for='$driver-driver'>Driver</label></td>\n<td>";
	$html .= "<input type='text' name='$driver-driver' id='$driver-driver' value='$module' readonly='readonly' />\n";
	$html .= "</td>\n";
	$html .= "<td>\n";
	$html .= " &nbsp; <img src='images/icons/shield-help.png' class='help_icon' alt='driver' title='driver' />\n";
	$html .= "</td>\n";
	$html .= "</tr>\n";
	foreach ($field_array as $key => $value) {
		if ($settings) { @$value = $settings[$key]; }
		$html .= "<tr>\n";
		$html .= "<td><label for='$driver-$key'>" . ucwords(str_replace('_', ' ', $key)) . "</label></td>\n<td>";
		switch ($field_array[$key]['input']) {
			case 'string': case 'int':
				if (is_array($value) && $key === 'bind_secret') {
					if (isset($value['file'])) {
						$value = 'file: ' . $value['file'];
					} elseif (isset($value['config'])) {
						$value = 'config: ' . $value['config'];
					}
				}
				if (!$newForm)
					$html .= "<input id='$driver-$key' name='$driver-$key' type='text' size='30' value='$value' />\n";
				else
					$html .= "<input id='$driver-$key' name='$driver-$key' type='text' size='30' />\n";
				break;
			case 'bool':
				if (!$newForm) {
					$checked = ($field_array[$key]['value'] == $value) ? "checked" : "";
				}
				else
					$checked = "";
				$html .= "<input id='$driver-$key' name='$driver-$key' type='checkbox' value='1' $checked />\n";
				break;
			case 'select':
				$options = explode(',', $field_array[$key]['value']);
				$html .= "<select name='$driver-$key' id ='$driver-$key'>\n";
					foreach ($options as $option) {
						if (!$newForm)
							$selected = ($value == $option) ? "selected='selected'" : "";
						else
							$selected = "";
						$html .= "<option value='$option' $selected>$option</option>\n";
					}
				$html .= "</select>\n";
				break;
		}
		$html .= "</td>\n";
		$html .= "<td>\n";
		$html .= "<img src='images/icons/shield-help.png' class='help_icon' alt='$key' title='$key' />\n";
		$html .= "</td>\n";
		$html .= "</tr>\n";
	}
	$html .= "</table>\n";
	echo $html;
}

function backupConfiguration() {
	$dateTime = strftime("%Y%m%d-%H%M%S", time());
	$configPath = "/etc/op5/";
	$currentConfig = $configPath . "auth.yml";
	$backupConfig = $configPath . "auth-" .$dateTime .  ".yml";
	$command = 'cp ' . $currentConfig . ' ' .$backupConfig;
	chmod($configPath, 0664);
	if (exec($command))	{
		echo "Backup was successfully created";
	} else {
		echo "There was an error creating the backup." . $command;
	}
}

//Handles ajax call for new driver.
if (@$_REQUEST['action'] == 'newAuthDriverForm') {
	$name = $_REQUEST['name'];
	$type = $_REQUEST['type'];
	return driverForm($name, $type, false);	
}
elseif (@$_REQUEST['action'] == 'backupConfiguration') {
	return backupConfiguration();
}

?>
