/**
*	Get value of command field
*	fieldToFind is the last part (command_name or command_line) of the
*	element name. This to enable us to get the command[80][command_name]
*	without having to know the id. (Another solution could be to add a hidden
*	field with just the id...)
*/
function commandGetElementValue(f, fieldToFind)
{
	for(var i=0; i<f.elements.length; i++){
		if (f.elements[i].name) {
			if (f.elements[i].name.search(fieldToFind)>0 && f.elements[i].type=='text'){
				return f.elements[i].value;
			}
		}
	}
}

/**
*	Print form to enter command params
*		Expand $USER$ macros
*/
function printCmdForm(f, fieldToFind)
{
	// Fetch value from displayed form
	var cmdVal = commandGetElementValue(f, fieldToFind);

	// create object for $USER1-3$ macros
	var userPaths = {};
	userPaths['USER1'] = '/opt/plugins';
	userPaths['USER2'] = '/opt/plugins/suid';
	userPaths['USER3'] = '/opt/monitor/op5';

	// Replace plugin path
	// Ought to be created by PHP in html_start
	// --------------------------------------------------------------
	if (cmdVal.search(/USER1/)>=0){
		cmdVal = cmdVal.replace(/\$USER1\$/, userPaths['USER1']);
	}
	if (cmdVal.search(/USER2/)>=0){
		cmdVal = cmdVal.replace(/\$USER2\$/, userPaths['USER2']);
	}
	if (cmdVal.search(/USER3/)>=0){
		cmdVal = cmdVal.replace(/\$USER3\$/, userPaths['USER3']);
	}
	// --------------------------------------------------------------

	// a valid command value shouldn't be too short...
	if (cmdVal.length<5){
		return false;
	}

	// Create new form - add onsubmit eventhandler to prevent user from regular submit...
	var outPut = "<form action=\"\" method=\"post\" id=\"commandTestForm\" onsubmit=\"processCommand(this);return false;\">";

	// Print form
	var hostselector = $('#commandTest .extra_test');
	hostselectior = hostselector ? hostselector : '';
	var commandTest = $('#commandTest');
	outPut += "<input type=\"text\" class=\"xlarge\" name=\"cmdString\" value=\"" + cmdVal + "\" />";
	outPut += " <input type=\"button\" class=\"button continue\" name=\"tmpBtn\" value=\"Continue\" onclick=\"processCommand(this.form)\"></form>";
	outPut += "<div id=\"cmdOutput\" style=\"display:none;\"></div>";
	commandTest.html(outPut);
	commandTest.find('input:last').after(hostselector);
	commandTest.show();

	var cmdTestButton = document.getElementById('cmdTestButton');
	cmdTestButton.setAttribute('class', "button hide-test-form");
	cmdTestButton.setAttribute('title', "Click to hide test form");
	cmdTestButton.setAttribute('value', "Hide test form");
	cmdTestButton.onclick = function(){hideCmdForm();};
}

function testService(f, hostIdFieldName)
{
	// what fields holds the values we seek?
	var cmdFieldName = '\\[check_command\\]';
	var cmdFieldVal = f.tmp_obj_id.value;
	var argFieldName = '\\[check_command_args\\]';
	var argFieldVal = false; // value of command_args
	var is_argField = false; // is argument field visible?
	var is_host = false;

	hostIdFieldName = (hostIdFieldName == null) ? 'master_obj_id' : hostIdFieldName;
	var hostIdFieldVal = false;
	var missing_fields = "";
	var obj_type = $('input[name=obj_type]').val();
	var selected_command_id = $('select[name*=check_command]').val();
	var template_id = $('select[name*=template]').val();

	// Are we checking a host?
	if (hostIdFieldName=='tmp_obj_id') {
		is_host = true;
	}

	// Loop through form and lookout for check_command and check_command_args
	for(var i=0; i<f.elements.length; i++){
		if (f.elements[i].name){
			if (f.elements[i].name.search(argFieldName)>0){
				argFieldVal = f.elements[i].value;
				is_argField = true;
			}
			if (f.elements[i].name==hostIdFieldName){
				hostIdFieldVal = f.elements[i].value;
			}
		}
	}

	if (!cmdFieldVal || (is_argField && !argFieldVal) || !hostIdFieldVal){
		if (!cmdFieldVal)
			missing_fields += " - check_command\n";
		if (is_argField){
			// if arg field not available, we don't need it...
			if (!argFieldVal)
				missing_fields += " - check_command_args\n";
		}
		if (!hostIdFieldVal)
			missing_fields += " - host_address\n";
	}

	var cmdTestButton	= document.getElementById('cmdTestButton');

	// Disable button until processing done...
	setDisabled('cmdTestButton', 'processing');
	$('.extra_test').hide();

	if (hostIdFieldName=='master_obj_id') {
		cmdTestButton.onclick = function(){hideCmdForm(true);};
	} else {
		cmdTestButton.onclick = function(){hideCmdForm(true, 'tmp_obj_id');};
	}

	var address = $('input[name=host\\[' + $('input[name=tmp_obj_id]').val() + '\\]\\[address\\]]').val();
	if (typeof address == 'undefined') {
		// unset address if nothing found
		address = '';
	}

	var address_cmd = '';
	if (address != '') {
		address_cmd = '&address=' + address;
	}
	var cmdStr = "cmdID=" + cmdFieldVal + "&cmdArgs=" + encodeURIComponent(argFieldVal) + "&hostId=" + hostIdFieldVal + "&obj_type=" + obj_type + "&selected_command_id=" + selected_command_id + "&template_id=" + template_id + address_cmd;
	if (f.cmdTestNode)
		cmdStr += '&cmdTestNode=' + f.cmdTestNode.value;

	cmdTestButton.className	= is_host ? 'button test-this-host' : 'button test-this-service';
	var cmdOutput = document.getElementById('commandTest');
	cmdOutput.style.display = "block";

	processCommand(cmdStr, true);
}

function hideCmdForm(isService, field_name)
{
	field_name = (field_name == null) ? false : field_name;
	isService = (isService == null) ? false : true;
	var cmdTestButton = document.getElementById('cmdTestButton');
	if (!isService){
		cmdTestButton.className = 'button test-this-command';
		cmdTestButton.onclick = function(){printCmdForm(this.form, 'command_line');};
		cmdTestButton.setAttribute('title', "Click to test this command");
		cmdTestButton.setAttribute('value', "Test this command");
	} else {
		if (field_name!=''){
			cmdTestButton.className = 'button test-this-host';
			cmdTestButton.value = 'Test this host';
			cmdTestButton.onclick = function(){testService(this.form, field_name);};
			cmdTestButton.setAttribute('title', "Click to test command with the values entered above");
		} else {
			cmdTestButton.className = 'button test-this-service';
			cmdTestButton.value = 'Test this service';
			cmdTestButton.onclick = function(){testService(this.form);};
			cmdTestButton.setAttribute('title', "Click to test service with the values entered above");
		}
		$('.extra_test').show();
	}

	var commandTest = document.getElementById('commandTest');
	commandTest.style.display = "none";
	commandTest.style.backgroundColor = "#ffffff"; // reset bgcolor
	$(commandTest).html('');
}

/**
*	Validate commandline input before we pass it on...
*/
function validateCommand(command)
{
	if (command.length<5){
		alert("Please enter a valid command");
		return false;
	}
	var parts = command.split(" ");
	for (var i=0;i<parts.length;i++){
		var cmdParts = Array();
		parts[i] = trim(parts[i]);
		if (parts[i].search(/^\$/)>=0){ // found '$'
			alert("Please replace all macros (delimited by $) with actual values");
			return false;
		}
	}
	return true;
}

/**
*	Process the command entered by user.
*	Validation is made before we continue.
*/
function processCommand(f, isService)
{
	isService = (isService == null) ? false : true;
	var cmdUrl 	= isService ? "command_test.php?" : "command_test.php?cmd_str=";
	var param 	= isService ? f : encodeURIComponent(f.cmdString.value);
	if (!isService && f.cmdTestNode)
		param += '&cmdTestNode=' + f.cmdTestNode.value;
	if (!validateCommand(decodeURIComponent(param)) ){
		return false;
	}

	if (param.length>5){
		$('#cmdOutput').html(''); // empty output div
		cmdHttp.open("GET", cmdUrl + param, true);
		cmdHttp.onreadystatechange = isService ? handleServiceResponse : handleCmdResponse;
		cmdHttp.send(null);
	}
	return false;
}

/**
*	Handle the HTTP response - only display
*	result on a 200 response
*/
function handleCmdResponse() {
	if (cmdHttp.readyState == 4) {
		var cmdOutput = document.getElementById('cmdOutput');
		if(cmdHttp.status==200) {
			var results = cmdHttp.responseText;
			cmdOutput.innerHTML = results;
		} else {
			cmdOutput.innerHTML = "Permission denied";
		}
		cmdOutput.style.display = "block";
	}

}

/**
*	Handle the HTTP response - only display
*	result on a 200 response
*/
function handleServiceResponse() {
	if (cmdHttp.readyState == 4) {
		var cmdOutput = document.getElementById('commandTest');
		if(cmdHttp.status==200) {
			var results = cmdHttp.responseText;
			cmdOutput.innerHTML = results;
			setEnabled('cmdTestButton', 'hide-test', 'Hide test');
		} else {
			cmdOutput.innerHTML = "Permission denied";
			setEnabled('cmdTestButton', 'hide-test', 'Hide test');
		}
		cmdOutput.style.display = "block";
		cmdOutput.style.backgroundColor = "#f2f2f2";
	}
}

function createProfileDetails(ItemCount, theId)
{
	$("#" + theId).show();
	var str = "";
	for (var i=0;i<ItemCount;i++){
		str += "<tr class=\"header\"><td colspan=\"2\" style='padding-left: 7px'>Item  #" + (i+1) + ":</td></tr>";
		str += printProfileTextbox('host_name', '', i);
		str += printProfileTextbox('address', '', i);
		str += printProfileTextbox('alias', '', i);
		//str += "</table></td></tr>";
	}
	if (str!=""){
		str += "<tr class=\"td-button\"><td>&nbsp;</td><td><input type=\"hidden\" name=\"action\" value=\"create\"><input onclick=\"checkAndSubmit('prototype', this.form);\" type=\"submit\" value=\"Create\" title=\"Create\" class=\"button create\" name=\"action_dummy\" /></td></tr>";
		$("#" + theId).html("<table class=\"magic max zebra ObjTable\">" + str + "</table>");
		onzebrachange($('#' + theId)[0]);
	}
}

function printProfileTextbox(theVar, theVal, cnt)
{
	var the_str;

	the_str =  "<tr>\n<td class=\"VarList\">" + theVar + "</td>\n";
	the_str += "<td><input type=\"text\" value=\"" + theVal + "\" name=\"clone_detail[" + cnt + "][" + theVar + "]\" class=\"large\" />\n";
	the_str += "</td>\n</tr>\n";
	return the_str;
}

function checkAndSubmit(theType, f)
{
	var isEmpty = false;
	var isFound = false;
	if (theType=='prototype'){
		for(var i=0; i<f.elements.length; i++){
			if (f.elements[i].name) {
				if (f.elements[i].name.search('clone_detail')>=0 && f.elements[i].type=='text'){
					if (trim(f.elements[i].value)==''){
						isEmpty = true;
						alert('Please fill in the form completely - all fields are required...');
						return false;
					}
					isFound = true;
				}
			}
		}
		if (!isFound){
			createProfileDetails(f.clone_targets.value, 'profile_details');
			return false;
		}
		return true;
	} else {
		return false;
	}
}

function validateDeleteProfile(profile_id, obj_type, page, obj_id){
	if(confirm('Are you sure that you wish to delete this profile?\nThis action cannot be undone...')){
		self.location.href='prototype.php?action=delete&profile_id=' + profile_id + '&obj_type=' + obj_type + "&ret_page=" + page + "&obj_id=" + obj_id;
	}
	return false;
}

function validate_delete_profile(profile_id, return_path){
	if(confirm('Are you sure that you wish to delete this profile?\nThis action cannot be undone...')){
		self.location.href='prototype.php?action=delete&profile_id=' + profile_id + '&return_path=' + return_path;
	}
	return false;
}

/**
*	Validate IP Range before submitting form
*/
function validate_ip_range(ip_range)
{
	ip_range = trim(ip_range);
	if (ip_range==''){
		alert('You must specify an IP-range to scan');
		return false;
	}
	//myRe = /[a-zA-Z]/gi;
	result = validate_ip(ip_range);
	//ip_range.search(myRe);
	if (result === true){
		setDisabled('ping_scan', 'Processing...');
		show_progress('progress_div', 'Processing... please wait');
		return true;
	} else {
		//alert(ip_range + ' is NOT a valid ip range.\nPlease try again...');
		var result_str = result!=false ? result + '\n\n' : '';
		alert(result_str + ip_range + ' is NOT a valid ip range.\nPlease try again...');
		return false;
	}
}

/* scan for services */

function processing_scan()
{
	setDisabled('scan-host-for-services', 'Processing...');
	show_progress('progress_div', 'Processing... please wait');
	return true;
}

/**
*	Validate an IP range from host wizard, network scan
*	Calls validate_ippart() for each (possibley commaseparated)
*	IP range
*/
function validate_ip(ip){
	ip = trim(ip);
	if(ip.length < 1) {
		return false;
	}
	var errors = 0;
	var err_str = '';
	var space_parts = false;
	if (ip.indexOf(' ')!= -1) {
		space_parts = ip.split(' ');
	}
	var ok = true;
	if (space_parts.length) {
		for (var i=0;i<space_parts.length;i++) {
			var tmp_ip = trim(space_parts[i]);
			ok_tmp = validate_ippart(tmp_ip);
			ok = !ok_tmp ? false : ok;
		}
		return ok;
	} else {
		ok = validate_ippart(ip);
		return ok;
	}
	return ok;
}
/**
*	Validate IP range when called from validate_ip()
*/
function validate_ippart(ip)
{
	var errors = 0;
	var err_str = '';
	ip = trim(ip);
	if(ip.length < 1) {
		return false;
	}
	var parts = ip.split('.');
	if (parts.length != 4) {
		err_str = 'Invalid target host specification: ' + ip;
		return err_str;
	}
	for (var i=0;i<parts.length;i++) {
		var start = false;
		var end = false;
		if (parts[i] == '*') {
			start = 0;
			end = 255;
		} else if (parts[i].indexOf('-') != -1) {
			start = 0;
			if (parts[i].length==1) {
				// nothing more, nothing less - just a hyphen
				end = 255;
			} else {
				var range_parts = parts[i].split('-');
				if (range_parts.length == 2) {
					start = range_parts[0];
					end = range_parts[1];
				} else {
					// start or end?
					if (range_parts[0]=='') {
						start = 0;
					} else {
						start = range_parts[0];
					}
					if (range_parts[1]=='') {
						end = 0;
					} else {
						end = range_parts[1];
					}
				}
			}
		} else if (parts[i].indexOf(',') != -1) {
			start = 0;
			if (parts[i].length>1) {
				var range_parts = parts[i].split(',');
				if (range_parts.length) {
					for (var a=0;a<range_parts.length;a++) {
						if (parseInt(range_parts[a]) != range_parts[a]) {
							errors++;
						}
					}
				}
				if (range_parts.length == 2) {
					start = range_parts[0];
					end = range_parts[1];
				} else {
					// start or end?
					if (range_parts[0]=='') {
						start = 0;
					} else {
						start = range_parts[0];
					}
					if (range_parts[1]=='') {
						end = 0;
					} else {
						end = range_parts[1];
					}
				}
			}
		} else {
			// no special chars detected, should be regular ip
			if (!ip_val_ok(parts[i])) {
				errors++;
			}
		}
		if (start != false && end != false) {
			if (!ip_val_ok(start) || !ip_val_ok(end)  || errors!=0) {
				err_str = 'Your host specifications are illegal!';
				return err_str;
			}
		}
	}
	return true;
}

/**
*	Test if single IP part is int and not > 255
*/
function ip_val_ok(val)
{
	myRe = /[a-zA-Z]/gi;
	if (isNaN(parseInt(val)) || parseInt(val) > 255 || val.search(myRe)!=-1) {
		return false;
	}
	return true;
}

// required fields object constructor
function required_vars(field, type)
{
	this.field = field;
	this.type = type;
}

// returns false if there's no error, or a message otherwise
function is_required_field_missing(f, obj_type, obj_id, field, type)
{
	var err_str = false;
	switch (type) {
		case 'mselect': case 'select':
			if (f.elements[obj_type + '[' + obj_id + '][' + field + '][]']) {
				var items = f.elements[obj_type + '[' + obj_id + '][' + field + '][]'].options.length;
				if (!items) {
					err_str = ' - Please select at least one item in ' + field + '\n';
				}
			}
			break;
		case 'string':
			if (f.elements[obj_type + '[' + obj_id + '][' + field + ']']) {
				var cur_val = trim(f.elements[obj_type + '[' + obj_id + '][' + field + ']'].value);
				f.elements[obj_type + '[' + obj_id + '][' + field + ']'].value = cur_val;
				if (cur_val == '') {
					err_str = ' - Missing value in ' + field + '\n';
				}
			}
			break;
		case 'int':
			if (f.elements[obj_type + '[' + obj_id + '][' + field + ']']) {
				var cur_val = trim(f.elements[obj_type + '[' + obj_id + '][' + field + ']'].value);
				f.elements[obj_type + '[' + obj_id + '][' + field + ']'].value = cur_val;
				if (cur_val=='' || isNaN(cur_val)) {
					err_str = ' - Please enter a valid integer value in ' + field + '\n';
				}
			}
			break;
		case 'checkbox': case 'radio':
			var selector = $('input[name*=' + field + ']');
			if (selector.length) {
				var cnt_checked = selector.filter(':checked').length;
				if (cnt_checked==0) {
					// check if there are any hidden 'n' fields
					// which will take over
					var n_field = false;
					n_field = $("input[name*='" +  obj_type + "[" + obj_id + "][" + field + "][n]']");
					if (!n_field.length) {
						err_str = ' - Please select at least one option for ' + field + '\n';
					}
				}
			}
			break;
		default:
			// skip if we failed to match type
			// (or if type is hidden)
	} // end switch

	return err_str;
}

/**
*	Validate required fields before submit.
*	Checks are made that required form field actually exists
*	since they may be "hidden" in the used template.
*/
function check_required_objects(f)
{
	var tmp_err = false;
	var err_str = '';
	var err_cnt = 0;
	var obj_type = $('input[name=obj_type]').val()!='' ? $('input[name=obj_type]').val() : false;
	var obj_id = f.tmp_obj_id ? f.tmp_obj_id.value : false;
	//Avoid the pesky concole errors if there are no required fields in the form
	if (typeof monitor_required_objects != 'undefined') {
		var req_len = monitor_required_objects ? monitor_required_objects.length :0;
	}
	// make sure we've got all values before entering the loop
	// or skip the whole thing
	if (req_len!=0 && obj_type!=false && obj_id!=false) {
		for (var a=0;a<monitor_required_objects.length;a++) {
			var msg = is_required_field_missing(f, obj_type, obj_id, monitor_required_objects[a].field, monitor_required_objects[a].type);
			// we always use the first error - the alternative is just a fallback
			if (msg && monitor_required_objects[a].req_alt && !is_required_field_missing(f, obj_type, obj_id, monitor_required_objects[a].req_alt, monitor_required_objects[a].alt_type))
					msg = false;
			if (msg) {
				err_cnt++;
				err_str += msg;
			}
		} // end for

		// special case for name field in templates
		// which isn't stored as required in object_properties.inc.php
		// but rather checked (hard coded) in object_class::validate_object()
		if (obj_type.indexOf('_template') !=-1) {
			var field = 'name';
			if (f.elements[obj_type + '[' + obj_id + '][' + field + ']']) {
				var cur_val = trim(f.elements[obj_type + '[' + obj_id + '][' + field + ']'].value);
				f.elements[obj_type + '[' + obj_id + '][' + field + ']'].value = cur_val;
				if (cur_val == '') {
					err_cnt++;
					err_str += ' - Missing value in ' + field + '\n';
				}
			}
		}

		if (err_cnt != 0) {
			var header_str = '******************************* ERROR ********************************\n';
			header_str += '  Your form wasn\'t processed since ';
			if (err_cnt > 1) { // trying to be gramatically correct :)
				header_str += 'some required fields were ';
			} else {
				header_str += 'a required field was ';
			}
			header_str += 'empty.\n';
			header_str += '  Please correct the following issue(s) and try again:\n';
			header_str += '**********************************************************************\n\n';
			var msg = header_str + err_str;
			alert(msg);
			return false;
		}
	} else {
		// check for duplicate interface names when performing an SNMP interface scan
		var if_names = [];
		var a = 0;
		var duplicates = 0;

		var hostlist = [];
		var a =  0;
		// find all host IDs
		$(".check_all_snmp").each(function() {
			var identifier_var = $(this).attr('op5_xtra').split('|');
			if (identifier_var.length) {
				var host_id = identifier_var[1];
				var identifier = identifier_var[0];
				var i = 0;
				$("input[name^='p_if_list[" + host_id + "]']").each(function() {
					if ($(this).attr('name').search('ifIndex')!=-1) {
						var interface_id = $(this).attr('value');
						// check if anything is "checked"
						$("input[name='interface_services[" + host_id + "][" + interface_id + "][" + identifier + "]']").each(function() {
							if (this.checked && !this.disabled) {
								// add only checked, not disabled items to list
								var if_name = $("input[name='p_if_list[" + host_id + "][" + interface_id + "][interface_name]']").attr('value');
								hostlist[a++] = new if_objects(host_id, interface_id, if_name, identifier);
							}
						});
					}
				});
			}
		});
		duplicates = check_duplicate_ifnames(hostlist);
		if (duplicates.length) {
			var msg = "Some of your interface names are identical which isn't allowed \nas it will break your config.\n";
			msg += duplicates.join('\n');
			msg += "\n\nPlease change this and try again.";
			alert(msg);
			return false;

		}
	}
	var prop2_val = "";
	$("input:hidden[name^='action']").each(function() {
		prop2_val = this.value;
	});
	if (prop2_val == 'prop2') {
		var selected_options = 0;
		$("select[name^='selection']").not("select[name^='selection_tmp']").each(function() {
			selected_options += this.options.length;
		});
		$("select[name^='selected_hosts']").not("select[name^='selected_hosts_tmp']").each(function() {
			selected_options += this.options.length;
		});
		$("select[name^='selected_hostgroups']").not("select[name^='selected_hostgroups_tmp']").each(function() {
			selected_options += this.options.length;
		});
		$("select[name^='selected_host_groups']").not("select[name^='selected_host_groups_tmp']").each(function() {
			selected_options += this.options.length;
		});
		$("select[name^='selected_services']").not("select[name^='selected_services_tmp']").each(function() {
			selected_options += this.options.length;
		});
		$("select[name^='selected_servicegroups']").not("select[name^='selected_servicegroups_tmp']").each(function() {
			selected_options += this.options.length;
		});
		$("select[name^='selected_service_groups']").not("select[name^='selected_service_groups_tmp']").each(function() {
			selected_options += this.options.length;
		});
		if (selected_options==0) {
			alert('Please select at least one ' + obj_type + ' object to propagate these settings to.');
			return false;
		}
	}
	return true;
}

function check_duplicate_ifnames(hostlist)
{
	var host_id = false;
	var last_host = 0;
	var ret_val = [];
	var i = 0;
	var q = 0;
	var if_names = [];
	for (var a=0;a<hostlist.length;a++) {
		host_id = hostlist[a].host;
		if (host_id != last_host) {
			// check for duplicates
			if (if_names.length) {
				var is_ok = compare_unique(if_names);
				if (is_ok!== true && is_ok !=0) {
					var host_name = $("input[name='p_host_list[" + last_host + "][host_name]']").attr('value');
					ret_val[q++] = 'Duplicates found for host ' + host_name + ': ' + find_duplicates(if_names).join(', ');
				}

			}
			if_names = [];
			i = 0;
			if_names[i++] = hostlist[a].iface_name + ', ' + hostlist[a].iface_type;
		} else {
			// add to existing array
			if_names[i++] = hostlist[a].iface_name + ', ' + hostlist[a].iface_type;
		}
		last_host = hostlist[a].host;
	}
	var is_ok = compare_unique(if_names);
	if (is_ok!== true && is_ok !=0) {
		var host_name = $("input[name='p_host_list[" + last_host + "][host_name]']").attr('value');
		ret_val[q++] = 'Duplicates found for host ' + host_name + ': ' + find_duplicates(if_names).join(', ');
	}
	return ret_val;
}

function compare_unique(if_list)
{
	var if_unique = $.unique(if_list);
	if (if_list.length != if_unique.length) {
		return (if_list.length - if_unique.length)+1;
	} else {
		return true;
	}
}

/**
*	host, interface object for
'	interface name comparision
*/
function if_objects(host, iface, iface_name, iface_type)
{
	this.host = host;
	this.iface = iface;
	this.iface_name = iface_name;
	this.iface_type = iface_type;
}

find_duplicates = function( a, b ) {
	var res = [];
	for (var idx in a) {
		if ($.indexOf(a[idx], b))
			res.push(a[idx]);
	}
	return $.unique(res);
};

var TemplateClass = function(objtable) {
	this.objtable = objtable;
	this.lastval = $('.template_valuefield select option', objtable).filter(':selected').val();
	this.lasttext = $('.template_valuefield select option', objtable).filter(':selected').text();
	this.obj_type = $('input[name=obj_type]', objtable).attr('value');
	this.obj_id = $('input[name=tmp_obj_id]', objtable).attr('value');
	this.empty_str = '<i title="Value not defined in template">empty</i>'; // how to display empty template values

	var that = this;

	$('.template_valuefield select', objtable).change(function(ev) {
		that.get_template_diffs.call(that, that.lastval, $(this).val());
	});

	$('.force_template_btn', objtable).click(function() {
		$(this).attr('disabled', true).attr('value', 'Processing');
		that.set_new_template.call(that, true);
		$(this).attr('disabled', false).attr('value', 'Force template values');
	});
	$('.reset_changes', objtable).live('click', function() {
		if (that.obj_id == 'new' || that.obj_type == 'new_host' || that.obj_type == 'new_service')
			self.location.reload();
		else
			self.location.href = 'edit.php?obj_type=' + that.obj_type + '&obj_id=' + that.obj_id;
	});

	$('.template_valuefield select option', objtable).filter(':selected').each(function() {
		if ($(this).val() == '0') {
			$(this).parent().nextAll('.show_template_values_btn').hide();
		} else {
			$(this).parent().nextAll('.show_template_values_btn').show();
		}
	});

	$('.show_template_values_btn', objtable).click(function() {
		$(this).attr('disabled', true).attr('value', 'Processing');
		that.show_template_values();
		$(this).attr('disabled', false).attr('value', 'View template values');
	});
}

/**
 * Fetch the saved object data for one object
 */
TemplateClass.prototype.get_object_data = function(cb, final_var, obj_id, obj_type) {
	if (!final_var)
		final_var = 'object';
	if (!obj_id)
		obj_id = this.obj_id;
	if (!obj_type)
		obj_type = this.obj_type;

	if (this.objectcache && this.objectcache[obj_type] && this.objectcache[obj_type][obj_id]) {
		this[final_var] = this.objectcache[obj_type][obj_id];
		cb.call(this, this[final_var]);
		return;
	}

	var that = this;
	$.ajax({
		url: 'ajax_helper.php?action=object_data&obj_type=' + obj_type + '&obj_id=' + obj_id,
		dataType: 'json',
		success: function(data) {
			if (data == "ERROR") {
				alert("Error when fetching object data.\nPlease try again...");
			} else {
				if (!that.objectcache)
					that.objectcache = {};
				if (!that.objectcache[obj_type])
					that.objectcache[obj_type] = {};
				that.objectcache[obj_type][obj_id] = data;
				that[final_var] = data;
				cb.call(that, data);
			}
		}
	});
}

TemplateClass.prototype.get_template_diffs = function(oldtmplid, newtmplid) {
	var obj_type = $('input[name=obj_type]', this.objtable).val();
	var obj_id = $('input[name=tmp_obj_id]', this.objtable).val();
	$('.possible_changes', this.objtable).remove();
	this.show_template_diffs();
}

TemplateClass.prototype.show_template_diffs = function() {
	var that = this;
	var cb =  trigger_cb_on_nth_call(function() {
		var possible_changes = [];
		for (var item in that.object) {
			if (item === 'name' || item === 'register' || item === 'template' || item === 'id') {
				continue;
			}
			// show row in case it has previously been hidden
			$('.' + item + '_row').show();

			var change = {item:item, template_val:that.template_data[item], prev_template_val:that.old_data[item]};
			possible_changes.push(change);
		}

		// remove possible previous changes table
		$(that.objtable).prev('.possible_changes').remove();

		if (!possible_changes.length) {
			return;
		}
		var changes = '';
		var found_changes = true;
		changes += '<tr>';
		changes += '<td align="center"><strong>Variable</strong></td>';
		changes += '<td align="center"><strong>Old Template Value</strong> (' + that.lasttext + ')</td>';
		changes += '<td align="center"><strong>New Template Value</strong> (' +  $('.template_valuefield select option', that.objtable).filter(':selected').text() + ')</td>';
		changes += '</tr>';

		for (var i = 0; i<possible_changes.length;i++) {
			var mark_change;
			if (possible_changes[i].prev_template_val == possible_changes[i].template_val)
				mark_change = false;
			else
				mark_change = true;

			var tr_style = mark_change ? 'background:#ffaa00;' : '';
			var tr_class = mark_change ? 'found_changes' : '';
			var tr_title = mark_change ? 'Found changes between templates' : '';

			var old_val = possible_changes[i].prev_template_val;
			if (typeof old_val == 'object')
				old_val = old_val.join('<br />');
			if (!old_val)
				old_val = that.empty_str;
			var new_val = possible_changes[i].template_val;
			if (typeof new_val == 'object')
				new_val = new_val.join('<br />');
			if (!new_val)
				new_val = that.empty_str;

			changes += '<tr style="' + tr_style + '" title="' + tr_title + '" class="' + tr_class + '">';
			changes += '<td><strong>' + possible_changes[i].item + '</strong></td>';
			changes += '<td align=right>';
			changes += old_val;
			changes += "</td><td align=right>";
			changes += new_val;
			changes += "</td></tr>";
		}

		var header = '<tr><td colspan="2">The following changes will be made by this template switch:</td><td align="right"></td></tr>';
		var execute_btn = '<input type="button" class="execute_changes" value="Apply Template Changes" />';
		var footer = '<tr class="changes_footer"><td colspan=3><br /><form><input type="button" class="reset_changes" value="Reset" /> ' + execute_btn + '</form></td></tr>';
		$(that.objtable).before('<table border=0 cellpadding=3 class="possible_changes">' + header + changes + footer + '</table>');
		var change_tbl = $(that.objtable).prev('.possible_changes');
		change_tbl.css('margin-left', '20px').css('border', '1px solid black').css('display', 'none');
		$('tr', change_tbl).filter(':odd').not('.found_changes').css('background', '#c0c0c0');
		$('.changes_footer', change_tbl).css('background', '#ffffff');
		$('.force_template_btn', that.objtable).hide();
		$('.execute_changes', change_tbl).click(function() {
			that.set_new_template.call(that, false);
			$(that.objtable).prev('.possible_changes').remove();
			that.lastval = $('.template_valuefield select option', that.objtable).filter(':selected').val();
			that.lasttext = $('.template_valuefield select option', that.objtable).filter(':selected').text();
		});
		// check cell values when all ids has been expanded to their real values
		// this is to mark changes between values of type object properly
		that.mark_changes(change_tbl);

		$('.force_template_btn', that.objtable).show();
	}, 3);

	this.get_object_data.call(this, cb);
	this.get_object_data.call(this, cb, 'old_data', this.lastval, this.obj_type + '_template');
	this.get_object_data.call(this, cb, 'template_data', $('.template_valuefield select option', this.objtable).filter(':selected').val(), this.obj_type + '_template');
};

/**
 * Set values to those specified in template
 *
 * This is messy, but it has to be - we must detect the actual widget from the page,
 * rather than use the widget definition, as the widget definition might have fancy
 * higher-level stuffs that we don't understand. Yes, this is fragile and will break,
 * yes, we should replace this with server-side rendered widgets to make it less
 * error-prone, but that will have to wait for another day.
 */
TemplateClass.prototype.set_new_template = function(aggressive) {
	var that = this;
	var template_id = $('.template_valuefield select option', this.objtable).filter(':selected').val()
	var cb = trigger_cb_on_nth_call(function() {
		var str = "";
		var i;

		for (var item in that.object) {
			var objrow = $('.' + item + '_row', that.objtable);
			if (!objrow.length)
				continue;
			if (!that.template_data[item] && !that.old_data[item])
				continue;
			if (!aggressive && that.object[item] && that.old_data[item] != that.object[item]) {
				var mismatch = true;
				if (typeof that.object[item] == 'object' && that.object[item].length && that.old_data[item].length === that.object[item].length) {
					mismatch = false;
					for (i=0; i<that.old_data[item].length;i++) {
						if (that.old_data[item][i] != that.object[item][i]) {
							mismatch = true;
							break;
						}
					}
				}
				if (mismatch)
					continue;
			}

			objrow.show();

			var input;

			// Let's start with mselect widgets. They're complicated and have many input elements
			var tmp_input = $("select[name^='" + that.obj_type + "_tmp']", objrow);
			if (tmp_input.length) {
				input = $("select[name^='" + that.obj_type + "[" + that.obj_id + "][" + item + "]']", that.objrow);
				// remove all previously selected
				input.find('option').each(function() {
					tmp_input.addOption($(this).attr('value'), $(this).text());
					$(this).remove();
				});

				// select chosen ones
				for (i=0; i<that.template_data[item].length; i++) {
					var value = that.template_data[item][i];
					tmp_input.find('option').filter("[text='"+value+"']").each(function(){
						input.addOption($(this).attr('value'), $(this).text());
						$(this).remove();
					});
				}

				input.sortOptions();
				tmp_input.sortOptions();
				continue;
			}

			// Then go for free-text(y) strings
			input = $("input[name^='" + that.obj_type + "[" + that.obj_id + "][" + item + "]']:not(:radio):not(:checkbox):not(:hidden)", objrow);
			if (input.length) {
				$(input).attr('value', that.template_data[item]);
				continue;
			}

			// image?
			input = $("." + item + "_valuefield:has(img.selected_preview)");
			if (input.length) {
				// use regular image switch code as far as possible
				if (that.template_data[item]) {
					input.find('.image_container img#' + that.template_data[item].replace(/\./, '\\.')).click();
				} else {
					input.find('.remove_image').click();
				}
				continue;
			}

			// No free text strings, let's search for radio buttons or checkboxes
			input = $("input[name^='" + that.obj_type + "[" + that.obj_id + "][" + item + "]']", objrow);
			if (input.length) {
				var checkbox_values = that.template_data[item];

				if (typeof checkbox_values == 'string')
					checkbox_values = [checkbox_values];

				if (checkbox_values.length < 1)
					continue;
				input.attr('checked', false);
				for (i = 0;i<checkbox_values.length;i++) {
					$("input[name='" + that.obj_type + "[" + that.obj_id + "][" + item + "][" + checkbox_values[i] + "]']").attr('checked',true);
				}
				continue;
			}

			// No, so regular select, then.
			input = $("select[name^='" + that.obj_type + "[" + that.obj_id + "][" + item + "]'] option", that.objrow);
			input.each(function(){
				if ($(this).text() == that.template_data[item]) {
					$(this).attr('selected', true);
				}
			});
		}
	}, 3);
	this.get_object_data.call(this, cb, 'template_data', template_id, this.obj_type + '_template');
	this.get_object_data.call(this, cb, 'old_data', this.lastval, this.obj_type + '_template');
	this.get_object_data.call(this, cb);
};

TemplateClass.prototype.show_template_values = function() {
	var that = this;
	var template_id = $('.template_valuefield select option', this.objtable).filter(':selected').val();
	this.get_object_data.call(this, function() {
		var newfield = $('.newfield', that.objtable);
		var show_template_values_btn = $('.show_template_values_btn', that.objtable);
		if (newfield.is(':visible')) {
			newfield.remove();
			show_template_values_btn.attr('value', 'View template values');
			return;
		} else {
			show_template_values_btn.attr('value', 'Hide template values');
		}

		if (typeof that.template_data == 'undefined') {
			alert('Failed to fetch template data - please try again');
			newfield.remove();
			show_template_values_btn.attr('value', 'View template values');
			return;
		}

		if (!that.template_data) {
			return;
		}

		var rows = $('> tbody > tr', that.objtable).filter('[class]');
		// Add new table cell with class newfield to be used later on
		rows.each(function() {
			var td_count = $('td', that).length;
			$(this).append('<td class="newfield" align="right"></td>');
			var classname = $(that).find('td:eq('+(td_count-1)+')').attr('class');
			$(this).find('td:eq('+td_count+'4)').addClass(classname);
		});

		newfield = $('.newfield', that.objtable);
		// set style for newfield table cell
		newfield
			.css('background', '#cfcfcf')
			.css('border-top', '1px solid #dcdccd');

		$(".testButton", that.objtable).attr('colspan', 5); //increment colspan for testbutton row

		for (var attr in that.template_data) {
			var attr_id = attr + '_row';
			var row = rows.filter('.'+attr_id);
			var val = that.template_data[attr];
			if (typeof val == 'object')
				val = val.join('<br />');
			if (!val)
				val = that.empty_str;
			var basename = that.obj_type + "[" + that.obj_id + "][" + attr_id + "]";
			$('.newfield', row).html('<span id="' + basename + '_new">' + val + '</span>');
		}

		// add new column header
		$('.template_row', that.objtable).find('td:eq(4)').css('vertical-align', 'bottom').html('<strong>Template values</strong>');
	}, 'template_data', template_id, that.obj_type + '_template');
};

TemplateClass.prototype.mark_changes = function(changes)
{
	var i = 0;
	var seen_changes = false;
	var that = this;
	$('td:nth-child(2)', changes).each(function() {
		if (i > 1) {
			var cell2 = $(this).closest('tr').find('td:eq(2)').text();
			if ($(this).text() != cell2) {
				seen_changes = true;
				$(this).closest('tr').not('#changes_footer').css('background', '#ffaa00');
			} else {
				$(this).closest('tr').hide();
			}
		} else {
			if (i == 0) {
				$(this).closest('tr').find('td:eq(1)').html('<a href="#" class="show_all_template_values">Show all</a>');
			}
		}
		i++;
	});
	changes.show();
	$('.show_all_template_values', changes).click(function() {
		var show_all = 'Show all';
		var show_less = 'Show less';
		$('tr', changes).show();
		if ($(this).text() == show_all) {
			$(this).text(show_less);
			$('tr', changes).show();
		} else {
			that.mark_changes(changes);
		}
		return false;
	});
	if (!seen_changes) {
		$('tr:eq(0) td:nth-child(1)', changes).text('No changes detected between templates.');
		$('tr:eq(1)', changes).hide();
		$('.reset_changes', changes).hide();
		$('.execute_changes', changes).hide();
	}
};

var cmdHttp = getHTTPObject(); // The HTTP Object

var logo_path = "/ninja/application/media/images/logos/";
var preview_options = {
		containerID: 'imgPreviewWithStyles',
		srcAttr: 'src',
		distanceFromCursor: {top:-30,left:5},
		// When container is shown:
	    onShow: function(link){
	        // Animate link:
	        $(link).stop().animate({opacity:0.4});
	        // Reset image:
	        $('img', this).stop().css({opacity:0});
	    },
	    // When image has loaded:
	    onLoad: function(){
	        // Animate image
	        $(this).animate({opacity:1}, 300);
	    },
	    // When container hides:
	    onHide: function(link){
	        // Animate link:
	        $(link).stop().animate({opacity:1});
	    }
	}
$(document).ready(function()
{
	$('.CmdBarItem a.delete').click(function(ev) {
		var name = $(this).parent().siblings(":first").text();
		return confirm("Are you sure you want to delete '"+name+"'?");
	});

	$('.multiple').live('dblclick', function() {
		var class_sel = '';
		
		if (!this.classList) {
			this.classList = $(this).attr('class').split(/\s+/);
		}
		
		for (var i = 0; i < this.classList.length; i++) {
			class_sel += '.' + this.classList[i];
		}
		var other = $('select').filter(class_sel).not(this);
		moveSelectedOption(this, other);
	});
	$('.ObjTable').each(function() {new TemplateClass(this);});
	$('.check_all').each(function() {
		$(this).click(function() {
			var checked_status = this.checked;
			var identifier = $(this).attr('op5_xtra');
			identifier = identifier.replace(/check\[/,'');
			identifier = identifier.replace(/\]/,'');
			$("input[name^='check[" + identifier + "]']").each(function() {
				this.checked = checked_status;
			});
		});
	});
	$(".check_all_snmp").each(function() {
		$(this).click(function() {
			var checked_status = this.checked;
			var identifier = false;
			var interface_id = false;
			var host_id = false;
			var identifier_var = $(this).attr('op5_xtra').split('|');
			if (identifier_var.length) {
				identifier = identifier_var[0];
				host_id = identifier_var[1];
				$("input[name^='p_if_list[" + host_id + "]']").each(function() {
					 if ($(this).attr('name').search('ifIndex')!=-1) {
						interface_id = $(this).attr('value');
						$("input[name='interface_services[" + host_id + "][" + interface_id + "][" + identifier + "]']").each(function() {
							this.checked = checked_status;
						});
					 }
				});
			} else {
				return;
			}
		});
	});

	// Logo / Image handling
	init_img_preview();

	$(".selected_preview_container").css('cursor', 'pointer').click(function() {
		toggle_and_mark($(this));
	});

	set_logo_click_action();

	$(".remove_image").click(function() { unset_icon($(this)) });

	// Other

	$(".show_template_values_btn").attr('title', 'View template values for current template');

	$('#win_service_form').bind('submit', function() {
		$('#error_msg').html('');
		var added = this["win_services[]"].length;
		var service_description = $('#service_description').val();
		var has_service_description = false;
		if (trim(service_description) != '') {
			has_service_description = true;
		}
		if (!added || !has_service_description) {
			$('#error_msg').html('<img src="images/icons/shield-critical.png" align="absmiddle"> <strong>Please add services to the right select box and enter a service description.</strong>');
			return false;
		}

		return true;
	});

	/**
	*	Mark host which have selected service
	*/
	$('#pnp_svc_select').change(function() {
		var sel_svc = $(this).val();
		pnp_trigger(sel_svc);
	});

	if (window['lock_obj_id'] && window['lock_obj_type']) {
		setup_lock_loop(lock_obj_id, lock_obj_type);
	}

	$('.selectall_accessbox').change(function() {
		var the_class = $(this).attr('class');
		the_class = the_class.replace('selectall_accessbox ', '');
		$('.' + the_class).attr('checked', $(this).attr('checked'));
	});

	$('.changelisting li').click(function() {
		var child = $(this).find('ul');
		if (child.is(':visible'))
			child.hide();
		else
			child.show();
	});
	if ($('.changesummary').length) {
		$('.changelisting li ul').hide();
		$('.changelisting').hide();
	}
	$('.changesummary').click(function() {
		var listing = $('.changelisting');
		if (listing.is(':visible')) {
			listing.hide();
			$(this).find('a').text('More info');
		} else {
			listing.show();
			$(this).find('a').text('Less info');
		}
	});
	$('.scan-host-for-services').click(function(){return test_if_user_is_contact(this)});
	$('.object-submit').click(function() {
		//Avoid pesky concole errors if obj_type is not set.
		if (typeof this.form.obj_type != 'undefined') {
			if (this.form.obj_type.value == 'host')
			return test_if_user_is_contact(this);
		}		
	});

	if (parent['onnacomaload'])
		parent.onnacomaload(window);

	$('table.zebra').each(function() {onzebrachange(this);});

	$('form#foobar_form').each(function() {
		if (this.obj_type.value != 'host')
			return;
		if (!(this.tmp_obj_id.value > 0)) // NOT, as tmp_obj_id can be "new"
			return;
		var mselect = this['host['+this.tmp_obj_id.value+'][hostgroups][]'];
		if (mselect) {
			var preselected = [];
			var hg_names = [];
			for (var i = 0; i < mselect.length; i++) {
				preselected.push(mselect[i].value);
				hg_names.push(mselect[i].label);
			}
			$(this).submit(function () {
				var postselected = [];
				var removed = [];
				for (var i = 0; i < mselect.length; i++) {
					postselected.push(mselect[i].value);
				}
				for (var i = 0; i < preselected.length; i++) {
					if ($.inArray(preselected[i], postselected) < 0) {
						$.ajax({
							url: 'ajax_helper.php?action=services_for_hostgroup&obj_id='+preselected[i],
							success: function(data) {
								if (typeof data == 'object')
									removed = removed.concat(data);
							},
							dataType: 'json',
							async: false
						});
					}
				}
				if (removed.length)
					return confirm("This save will remove the following hostgroup services from this host:\n * " + removed.join('\n * ') + '\nAre you sure?');
				return true;
			});
		}
	});

	$('.scan').mouseover(function() {
		if ($(this).next('.node_form').length)
			return;
		var action;
		// snmp scans don't need this, as there's a landing page for the user to choose
		if ($(this).hasClass('network'))
			action = 'scan';
		else
			return;

		var obj_id;
		var main_form = $(this).parents('form')[0];
		if (main_form.obj_type.value == 'host')
			obj_id = main_form.tmp_obj_id.value;
		else
			obj_id = main_form.master_obj_id.value;
		var that = this;

		$.ajax({
			url: 'ajax_helper.php?action=merlin_nodes',
			dataType: 'json',
			success: function(data) {
				var html = '<form class="node_form" method="GET" action="host_wizard.php">' +
					'<input type="hidden" name="action" value="'+action+'"/>' +
					'<input type="hidden" name="obj_id" value="'+obj_id+'"/>' +
					'<select name="poller_to_use" style="width: 150px">' +
					data.map(function(arg) {return '<option value="'+arg+'">'+arg+'</option>'}).join('') +
					'</select>' +
					'<input type="submit" value="Scan"/>' +
					'</form>';
				$(that).after(html);
			}
		});
	});
	$('#related').mouseleave(function(e) {
		// scary condition brought to you by
		// http://stackoverflow.com/questions/2096843/funky-jquery-mouseleave-behavior
		if ((typeof e.fromElement != 'undefined' && !e.fromElement.length) ||
			(typeof e.fromElement == 'undefined' && e.target.tagName != 'SELECT')) {
			$(this).find('.node_form').remove();
		}
	});

	$('input').filter('[name$="wmi\]"]').change(function() {
		if (!$(this).is(':checked')) {
			$(this).parents('table.box-table').next('div').remove();
			return;
		}
		var name = this.name;
		var nameprefix = name.substring(0, name.indexOf(']')+1);
		$(this).parents('table.box-table').after('<div><label for="'+nameprefix+'[wmi_username]">WMI Username:</label><input type="text" id="'+nameprefix+'[wmi_username]" name="'+nameprefix+'[wmi_username]"/><br/><label for="'+nameprefix+'[wmi_password]">WMI Password:</label><input type="password" id="'+nameprefix+'[wmi_password]" name="'+nameprefix+'[wmi_password]"/></div>');
	});

	$('#new_custom').click(function() {
		// Warning! This code needs to correspond to the similar code in gui class
		var form = $(this).parents('form');
		var obj_type = form.find('[name=obj_type]').val();
		var id = form.find('[name=tmp_obj_id]').val();
		var base_var_name = 'custom_vars[' + obj_type + '][' + id + ']';
		var line_start = "<td><input type='text' name='" + base_var_name;
		var i = form.find('.custom').length;
		$(this).parents('tr.custom').before("<tr class='custom'><td>&nbsp;</td><td></td>"+line_start+"["+i+"][key]'></td>"+line_start+"["+i+"][value]'><input type='button' class='remove_custom' value='Remove' /></td></tr>");
	});
	// dynamically added custom vars do not yet have prop boxes, so we don't
	// need to use .live()
	$('tr.custom').find('name$=\'[key]\'').change(function() {
		var prop_box = $(this).parents('tr.custom').find('.propagate_box');
		prop_box.attr('name', $(this).val().attr('id'), $(this).val());
	});
	$('tr.custom .remove_custom').live('click', function() {
		$(this).parents('tr.custom').remove();
	});

	// Minimal triggering of element changing, inspired by http://ejohn.org/blog/learning-from-twitter/
	var custom_keys_to_validate = [];
	$('tr.custom input[type=text]:even')
		.live('keypress', function() {
			custom_keys_to_validate.push($(this));
		})
		.live('change', function() {
			custom_keys_to_validate.push($(this));
		});
	setInterval(function() {
		var element_to_inspect;
		var tmp_value;
		while(custom_keys_to_validate.length) {
			element_to_inspect = custom_keys_to_validate.shift();
			// here's the key of this somewhat weird method:
			// only manipulate the DOM every x miliseconds
			tmp_value = element_to_inspect.val();
			if('_' !== tmp_value[0]) {
				tmp_value = '_'+tmp_value;
			}
			element_to_inspect.val(tmp_value.toUpperCase().replace(/ /g, '_'));
		}
	}, 500);
});

function onzebrachange(table) {
	$('> tbody > tr', table).removeClass('even').filter(':odd').addClass("even");
};

function setup_lock_loop(obj_id, obj_type) {
	lock_loop = function() {
		$.ajax({
			url: 'ajax_helper.php?action=extend_lock&obj_type='+obj_type+'&obj_id='+obj_id
		});
	};
	lock_loop();
	// locks are 60 seconds each, so call every 30 seconds, and we'll be able
	// to miss one
	setInterval(lock_loop, 30000);
}

function pnp_trigger(sel_svc)
{
	if (sel_svc == '') {
		return false;
	}

	var svc_pos = $('#pnp_svc_select').offset();
	var svc_width = $('#pnp_svc_select').css('width');
	svc_width = svc_width.replace('px', '');
	if (isNaN(svc_width)) {
		svc_width = 200;
	}
	var progress_left = (parseInt(svc_width) + parseInt(svc_pos['left']) + 10);

	$('#progress_div')
		.css('position', 'absolute')
		.css('top', (parseInt(svc_pos['top']) - 65))
		.css('left', progress_left);
	show_progress('progress_div', 'Processing... please wait');

	if ($('#hosts\\[\\] option').length) {
		// move elemtents in the selected (right) select box
		// to the left to make them available
		$('#hosts\\[\\] option').each(function() {
			$(this).appendTo($('#hosts_tmp\\[\\] optgroup'));
		});
		$('#hosts_tmp\\[\\] option').attr('selected', false);
		$('#hosts_tmp\\[\\]').sortOptions();
	}
	pnp_filter(sel_svc);
}

function pnp_filter(sel_svc) {
	$.ajax({
		url: 'ajax_helper.php?action=hosts_with_svc&service=' + sel_svc,
		dataType: 'json',
		success: function(data) {
			if (!data || !data.length) {
				// display error
				alert("Error when fetching data.\nPlease try again...");
			} else {
				var all = $('#hosts_tmp\\[\\] option');
				all.attr('disabled', true);
				all.attr('selected', false);
				all.css('color', '#999');
				for (var i = 0; i<data.length;i++) {
					var valid = $('#hosts_tmp\\[\\] option[value="' + data[i] + '"]');
					valid.attr('disabled', false);
					valid.attr('selected', true);
					valid.css('color', '#000');
				}
			}
			$('#progress_div').hide();
		}
	});
}

function pnp_trigger_selected()
{
	var sel_svc = $('#pnp_svc_select').val();
	if (sel_svc)
		pnp_filter(sel_svc);
}

/**
*	Toggle visibility of all images
*	and mark selected with a border
*/
function toggle_and_mark(obj)
{
	if (obj.parent().children(".image_container").length) {
		obj.parent().children(".image_container").toggle();
	}
	else {
		obj.parent().children('.remove_image').after($('.image_container'));
		obj.parent().children('.image_container').show();
	}
	init_img_preview();
	$(".host_logo_images").css('border', '0');
	var sel_id = obj.parent().children(".image_realname").text();
	if (sel_id) {
		$('.host_logo_images').filter('#' + sel_id.replace('.', '\\.')).css('border', '2px solid red');
	}
}

/**
*	Set current icon type as unselected, ie remove image,
*	empty hidden form field and remove the "Remove" link
*/
function unset_icon(obj)
{
	var no_image = 'images/icons/no_image.png';
	obj.parent().children(".host_logo_selected").attr('value', '');
	obj.parent().children(".image_realname").text('');
	obj.parent().children('.selected_preview_container').children(".selected_preview").attr('src', no_image);
	obj.parent().children(".remove_image").hide();
}

function init_img_preview()
{
	if ($(".image_container img").length)
		$(".image_container img").imgPreview(preview_options);
}

// take care of the click action when user selects a logo
//	image_realname - id where to set real name (filename) for selected host logo
//	host_logo_selected - id where to set attr(value) for selected host logo (int)
//	host_logo_images - class with all available host logos
function set_logo_click_action()
{
	$(".host_logo_images").each(function() {
		$(this).click(function() {
			$("#imgPreviewWithStyles").remove();
			$(this).parent().children(".host_logo_images").css('border', '0');
			$(this).css('border', '2px solid red');
			$(this).parent().parent().children(".host_logo_selected").attr('value', $(this).attr('id'));
			$(this).parent().parent().children(".image_realname").text($(this).attr('id'));
			$(this).parent().parent().children('.selected_preview_container')
				.children('.selected_preview').attr('src', $(this).attr('src'));
			//$(this).parent().parent().children(".selected_preview_host_logo").attr('src', $(this).attr('src'));
			$(this).parent().parent().children(".image_container").hide('slow');
			$(this).parent().parent().children(".remove_image").show();
		});
	});
}

/**
*	Javascript equivalent to PHP ucfirst()
*/
function ucfirst(str) {
    var First = str.charAt(0).toUpperCase();
    return First + str.substr(1, str.length-1);
}

function set_page_location(obj_type, sel, master_obj_link)
{
	var link = '';
	var selected_object_type = sel.value;

	if(obj_type == 'host' && $.inArray(selected_object_type, ['hostdependency', 'hostescalation', 'service']) >= 0)
		link = master_obj_link

	if(obj_type == 'service' && $.inArray(selected_object_type, ['servicedependency', 'serviceescalation', 'service']) >= 0)
		link = master_obj_link

	this.location.href='edit.php?obj_type=' + selected_object_type + '&list=true' + link;
}

/**
*	Yet another move options function.
*	This one also uses JQuery and works directly on the select
*	element and not on the options. It has the benefit of also
*	working with IE browsers.
*
*	Tested with IE7 and FF3
*
*	Only requires the from and to node/jqueryobj
*/
function moveSelectedOption(source, target)
{
	var opt = $("option:selected", source)
	if (!opt.disabled) {
		$(target).append(opt);
		$(target).sortOptions();
	}
}

function submit_propagate_settings(f)
{
	var cnt_checked = $("input:checkbox[name^='prop_vars']").filter(':checked').length;
	if (cnt_checked!=0) {
		f.action.value = 'propagate';
		f.onsubmit = '';
		loopElements(f);
		return true;
	} else {
		alert('Please select at least one property to propagate.');
		return false;
	}

}

function show_hide_propagate()
{
	$(".propagate-settings").toggle();
	$(".propagate_box").toggle();

}

function trigger_cb_on_nth_call(cb, n) {
	var that = this;
	var ret = function() {
		if (--n <= 0) {
			cb.call(that);
		}
	};
	return ret;
}

function test_if_user_is_contact(elem) {
	var ids = elem.form.tmp_obj_id;
	var obj_types = elem.form.obj_type;
	if (ids.length == undefined) {
		ids = [ids];
		obj_types = [obj_types];
	}
	var objs = [];
	for (var i = 0; i < ids.length; i++) {
		var id = ids[i].value;
		var obj_type = obj_types[i].value;
		var pretty_obj_type = obj_type.substr(0,4) == 'new_'?obj_type.substr(4):obj_type;
		// skip hosts we aren't even gonna add
		if (elem.form[obj_type+'['+id+'][Add this host?]'] && elem.form[obj_type+'['+id+'][Add this host?]'].value == '0')
			continue;

		var contacts='';
		var cgroups='';
		var template='';
		if (elem.form[obj_type+'['+id+'][contacts][]'])
			contacts = $.map(
				elem.form[obj_type+'['+id+'][contacts][]'].options,
				function (option) {return option.value}).join(';');
		if (elem.form[obj_type+'['+id+'][contact_groups][]'])
			cgroups = $.map(
				elem.form[obj_type+'['+id+'][contact_groups][]'].options,
				function (option) {return option.value}).join(';');
		if (elem.form[obj_type+'['+id+'][template]'])
			template = elem.form[obj_type+'['+id+'][template]'].value;
		objs.push({
			'obj_type': pretty_obj_type,
			'contacts': contacts,
			'contact_groups': cgroups,
			'template': template});
	}
	// As soon as we upgrade past jquery 1.4, jquery can serialize nested
	// arrays, so delete this
	// (stop laughing because this never got done!)
	var data = 'action=is_user_contact';
	for (var i = 0; i < objs.length; i++) {
		data += '&objs['+i+'][obj_type]='+objs[i].obj_type;
		data += '&objs['+i+'][contacts]='+objs[i].contacts;
		data += '&objs['+i+'][contact_groups]='+objs[i].contact_groups;
		data += '&objs['+i+'][template]='+objs[i].template;
	}

	var res = $.ajax({
		url: 'ajax_helper.php',
		'data': data,
		async: false
	});
	if (res.responseText == '0') {
		var message = ids.length == 1 ?
			'When you save this '+pretty_obj_type+' object, you will no longer be able to modify it.\n'+
			'Only contacts or members of the object\'s contact groups can modify it.\n'+
			'Do you still want to apply your changes to the object now?' :
			'When you save these '+pretty_obj_type+' objects, you will no longer be able to modify all of them.\n'+
			'Only contacts or members of the objects\' contact groups can modify them.\n'+
			'Do you still want to apply your changes to the objects now?';
		return confirm(message);
	}
	return true;
}
